/*
 * This file is part of PySide: Python for Qt
 *
 * Copyright (C) 2009-2010 Nokia Corporation and/or its subsidiary(-ies).
 *
 * Contact: PySide team <contact@pyside.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA
 *
 */


//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <typeresolver.h>
#include <typeinfo>
#include "pyside_qtgui_python.h"

#include "qstyleoptiontab_wrapper.h"

// Extra includes
#include <qstyleoption.h>
#include <qwidget.h>



// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QStyleOptionTab_Init(PyObject* self, PyObject* args, PyObject* kwds)
{
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType<QStyleOptionTab >()))
        return -1;

    QStyleOptionTab* cptr = 0;
    int overloadId = -1;
    SbkObject* sbkSelf = reinterpret_cast<SbkObject*>(self);


    int numArgs = PyTuple_GET_SIZE(args);
    PyObject* pyargs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "QStyleOptionTab", 0, 1, &(pyargs[0])))
        return -1;

    // Overloaded function decisor
    // 0: QStyleOptionTab()
    // 1: QStyleOptionTab(QStyleOptionTab)
    // 2: QStyleOptionTab(int)
    if (numArgs == 0) {
        overloadId = 0; // QStyleOptionTab()
    } else if (numArgs == 1 && SbkNumber_Check(pyargs[0])) {
        overloadId = 2; // QStyleOptionTab(int)
    } else if (numArgs == 1 && Shiboken::Converter< ::QStyleOptionTab >::isConvertible(pyargs[0])) {
        overloadId = 1; // QStyleOptionTab(QStyleOptionTab)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QStyleOptionTab_Init_TypeError;

    // Call function/method
    {
        switch (overloadId) {
            case 0: // QStyleOptionTab()
            {

                if(!PyErr_Occurred()) {
                    // QStyleOptionTab()
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionTab();
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 1: // QStyleOptionTab(QStyleOptionTab)
            {
                if (!Shiboken::Object::isValid(pyargs[0]))
                    return -1;
                QStyleOptionTab cppArg0 = Shiboken::Converter<QStyleOptionTab >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QStyleOptionTab(QStyleOptionTab)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionTab(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
            case 2: // QStyleOptionTab(int)
            {
                int cppArg0 = Shiboken::Converter<int >::toCpp(pyargs[0]);

                if(!PyErr_Occurred()) {
                    // QStyleOptionTab(int)
                    PyThreadState* _save = PyEval_SaveThread(); // Py_BEGIN_ALLOW_THREADS
                    cptr = new QStyleOptionTab(cppArg0);
                    PyEval_RestoreThread(_save); // Py_END_ALLOW_THREADS
                }
                break;
            }
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType<QStyleOptionTab >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QStyleOptionTab_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QStyleOptionTab_Init_TypeError:
        const char* overloads[] = {"", "PySide.QtGui.QStyleOptionTab", "int", 0};
        Shiboken::setErrorAboutWrongArguments(args, "PySide.QtGui.QStyleOptionTab", overloads);
        return -1;
}

static PyObject *Sbk_QStyleOptionTab___copy__(PyObject *self)
{
        QStyleOptionTab* cppSelf = 0;
        if (!Shiboken::Object::isValid(self))
            return 0;
        cppSelf = Shiboken::Converter<QStyleOptionTab*>::toCpp(self);
        PyObject* pyResult = 0;
        QStyleOptionTab* copy = new QStyleOptionTab(*cppSelf);
        pyResult = Shiboken::Converter<QStyleOptionTab*>::toPython(copy);
        Shiboken::Object::getOwnership(pyResult);

        if (PyErr_Occurred() || !pyResult) {
            Py_XDECREF(pyResult);
            return 0;
        }
        return pyResult;
}

static PyMethodDef Sbk_QStyleOptionTab_methods[] = {

    {"__copy__", (PyCFunction)Sbk_QStyleOptionTab___copy__, METH_NOARGS},
    {0} // Sentinel
};

static PyObject* Sbk_QStyleOptionTab_get_row(PyObject* self, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    PyObject* val = Shiboken::Converter< int >::toPython( Shiboken::Converter< QStyleOptionTab* >::toCpp(self)->row);
    return val;
}

static int Sbk_QStyleOptionTab_set_row(PyObject* self, PyObject* value, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'row' may not be deleted");
        return -1;
    }
    if (!SbkNumber_Check(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'row', 'int' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionTab* >::toCpp(self)->row = Shiboken::Converter< int >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionTab_get_cornerWidgets(PyObject* self, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    PyObject* val = Shiboken::Converter< ::QFlags<QStyleOptionTab::CornerWidget> >::toPython( Shiboken::Converter< QStyleOptionTab* >::toCpp(self)->cornerWidgets);
    return val;
}

static int Sbk_QStyleOptionTab_set_cornerWidgets(PyObject* self, PyObject* value, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'cornerWidgets' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QFlags<QStyleOptionTab::CornerWidget> >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'cornerWidgets', 'CornerWidgets' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionTab* >::toCpp(self)->cornerWidgets = Shiboken::Converter< ::QFlags<QStyleOptionTab::CornerWidget> >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionTab_get_position(PyObject* self, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    PyObject* val = Shiboken::Converter< ::QStyleOptionTab::TabPosition >::toPython( Shiboken::Converter< QStyleOptionTab* >::toCpp(self)->position);
    return val;
}

static int Sbk_QStyleOptionTab_set_position(PyObject* self, PyObject* value, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'position' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QStyleOptionTab::TabPosition >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'position', 'TabPosition' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionTab* >::toCpp(self)->position = Shiboken::Converter< ::QStyleOptionTab::TabPosition >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionTab_get_icon(PyObject* self, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    PyObject* val = Shiboken::createWrapper(&Shiboken::Converter< QStyleOptionTab* >::toCpp(self)->icon);
    Shiboken::Object::releaseOwnership(val);
    Shiboken::Object::setParent(self, val);
    return val;
}

static int Sbk_QStyleOptionTab_set_icon(PyObject* self, PyObject* value, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'icon' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QIcon >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'icon', 'QIcon' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionTab* >::toCpp(self)->icon = Shiboken::Converter< ::QIcon >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionTab_get_shape(PyObject* self, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    PyObject* val = Shiboken::Converter< ::QTabBar::Shape >::toPython( Shiboken::Converter< QStyleOptionTab* >::toCpp(self)->shape);
    return val;
}

static int Sbk_QStyleOptionTab_set_shape(PyObject* self, PyObject* value, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'shape' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QTabBar::Shape >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'shape', 'Shape' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionTab* >::toCpp(self)->shape = Shiboken::Converter< ::QTabBar::Shape >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionTab_get_text(PyObject* self, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    PyObject* val = Shiboken::Converter< QString >::toPython( Shiboken::Converter< QStyleOptionTab* >::toCpp(self)->text);
    return val;
}

static int Sbk_QStyleOptionTab_set_text(PyObject* self, PyObject* value, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'text' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< QString >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'text', 'QString' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionTab* >::toCpp(self)->text = Shiboken::Converter< QString >::toCpp(value);

    return 0;
}

static PyObject* Sbk_QStyleOptionTab_get_selectedPosition(PyObject* self, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    PyObject* val = Shiboken::Converter< ::QStyleOptionTab::SelectedPosition >::toPython( Shiboken::Converter< QStyleOptionTab* >::toCpp(self)->selectedPosition);
    return val;
}

static int Sbk_QStyleOptionTab_set_selectedPosition(PyObject* self, PyObject* value, void*)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    if (value == 0) {
        PyErr_SetString(PyExc_TypeError, "'selectedPosition' may not be deleted");
        return -1;
    }
    if (!Shiboken::Converter< ::QStyleOptionTab::SelectedPosition >::isConvertible(value)) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'selectedPosition', 'SelectedPosition' or convertible type expected");
        return -1;
    }

    Shiboken::Converter< QStyleOptionTab* >::toCpp(self)->selectedPosition = Shiboken::Converter< ::QStyleOptionTab::SelectedPosition >::toCpp(value);

    return 0;
}

// Getters and Setters for QStyleOptionTab
static PyGetSetDef Sbk_QStyleOptionTab_getsetlist[] = {
    {const_cast<char*>("row"), Sbk_QStyleOptionTab_get_row, Sbk_QStyleOptionTab_set_row},
    {const_cast<char*>("cornerWidgets"), Sbk_QStyleOptionTab_get_cornerWidgets, Sbk_QStyleOptionTab_set_cornerWidgets},
    {const_cast<char*>("position"), Sbk_QStyleOptionTab_get_position, Sbk_QStyleOptionTab_set_position},
    {const_cast<char*>("icon"), Sbk_QStyleOptionTab_get_icon, Sbk_QStyleOptionTab_set_icon},
    {const_cast<char*>("shape"), Sbk_QStyleOptionTab_get_shape, Sbk_QStyleOptionTab_set_shape},
    {const_cast<char*>("text"), Sbk_QStyleOptionTab_get_text, Sbk_QStyleOptionTab_set_text},
    {const_cast<char*>("selectedPosition"), Sbk_QStyleOptionTab_get_selectedPosition, Sbk_QStyleOptionTab_set_selectedPosition},
    {0}  // Sentinel
};

} // extern "C"

// Class Definition -----------------------------------------------
extern "C" {
static SbkObjectType Sbk_QStyleOptionTab_Type = { { {
    PyObject_HEAD_INIT(&SbkObjectType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "PySide.QtGui.QStyleOptionTab",
    /*tp_basicsize*/        sizeof(SbkObject),
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          &SbkDeallocWrapper,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        0,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          Sbk_QStyleOptionTab_methods,
    /*tp_members*/          0,
    /*tp_getset*/           Sbk_QStyleOptionTab_getsetlist,
    /*tp_base*/             0,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             Sbk_QStyleOptionTab_Init,
    /*tp_alloc*/            0,
    /*tp_new*/              SbkObjectTpNew,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
}, },
    /*priv_data*/           0
};
} //extern

PyObject* SbkPySide_QtGui_QStyleOptionTab_CornerWidget___and__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< QStyleOptionTab::CornerWidgets >::toPython(
        Shiboken::Converter<QStyleOptionTab::CornerWidgets>::toCpp(self)
        & Shiboken::Converter< QStyleOptionTab::CornerWidgets >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtGui_QStyleOptionTab_CornerWidget___or__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< QStyleOptionTab::CornerWidgets >::toPython(
        Shiboken::Converter<QStyleOptionTab::CornerWidgets>::toCpp(self)
        | Shiboken::Converter< QStyleOptionTab::CornerWidgets >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtGui_QStyleOptionTab_CornerWidget___xor__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< QStyleOptionTab::CornerWidgets >::toPython(
        Shiboken::Converter<QStyleOptionTab::CornerWidgets>::toCpp(self)
        ^ Shiboken::Converter< QStyleOptionTab::CornerWidgets >::toCpp(arg)
    );
}

PyObject* SbkPySide_QtGui_QStyleOptionTab_CornerWidget___invert__(PyObject* self, PyObject* arg)
{
    return Shiboken::Converter< QStyleOptionTab::CornerWidgets >::toPython(
        ~Shiboken::Converter<QStyleOptionTab::CornerWidgets >::toCpp(self)
    );
}


static PyNumberMethods SbkPySide_QtGui_QStyleOptionTab_CornerWidget_as_number = {
    /*nb_add*/                  0,
    /*nb_subtract*/             0,
    /*nb_multiply*/             0,
    /*nb_divide*/               0,
    /*nb_remainder*/            0,
    /*nb_divmod*/               0,
    /*nb_power*/                0,
    /*nb_negative*/             0,
    /*nb_positive*/             0,
    /*nb_absolute*/             0,
    /*nb_nonzero*/              0,
    /*nb_invert*/               (unaryfunc)SbkPySide_QtGui_QStyleOptionTab_CornerWidget___invert__,
    /*nb_lshift*/               0,
    /*nb_rshift*/               0,
    /*nb_and*/                  (binaryfunc)SbkPySide_QtGui_QStyleOptionTab_CornerWidget___and__,
    /*nb_xor*/                  (binaryfunc)SbkPySide_QtGui_QStyleOptionTab_CornerWidget___xor__,
    /*nb_or*/                   (binaryfunc)SbkPySide_QtGui_QStyleOptionTab_CornerWidget___or__,
    /*nb_coerce*/               0,
    /*nb_int*/                  0,
    /*nb_long*/                 0,
    /*nb_float*/                0,
    /*nb_oct*/                  0,
    /*nb_hex*/                  0,
    /*nb_inplace_add*/          0,
    /*nb_inplace_subtract*/     0,
    /*nb_inplace_multiply*/     0,
    /*nb_inplace_divide*/       0,
    /*nb_inplace_remainder*/    0,
    /*nb_inplace_power*/        0,
    /*nb_inplace_lshift*/       0,
    /*nb_inplace_rshift*/       0,
    /*nb_inplace_and*/          0,
    /*nb_inplace_xor*/          0,
    /*nb_inplace_or*/           0,
    /*nb_floor_divide*/         0,
    /*nb_true_divide*/          0,
    /*nb_inplace_floor_divide*/ 0,
    /*nb_inplace_true_divide*/  0,
    /*nb_index*/                0
};


// forward declaration of new function
static PyTypeObject SbkPySide_QtGui_QStyleOptionTab_CornerWidgets_Type = {
    PyObject_HEAD_INIT(&PyType_Type)
    /*ob_size*/             0,
    /*tp_name*/             "CornerWidgets",
    /*tp_basicsize*/        0,
    /*tp_itemsize*/         0,
    /*tp_dealloc*/          0,
    /*tp_print*/            0,
    /*tp_getattr*/          0,
    /*tp_setattr*/          0,
    /*tp_compare*/          0,
    /*tp_repr*/             0,
    /*tp_as_number*/        &SbkPySide_QtGui_QStyleOptionTab_CornerWidget_as_number,
    /*tp_as_sequence*/      0,
    /*tp_as_mapping*/       0,
    /*tp_hash*/             0,
    /*tp_call*/             0,
    /*tp_str*/              0,
    /*tp_getattro*/         0,
    /*tp_setattro*/         0,
    /*tp_as_buffer*/        0,
    /*tp_flags*/            Py_TPFLAGS_DEFAULT | Py_TPFLAGS_CHECKTYPES,
    /*tp_doc*/              0,
    /*tp_traverse*/         0,
    /*tp_clear*/            0,
    /*tp_richcompare*/      0,
    /*tp_weaklistoffset*/   0,
    /*tp_iter*/             0,
    /*tp_iternext*/         0,
    /*tp_methods*/          0,
    /*tp_members*/          0,
    /*tp_getset*/           0,
    /*tp_base*/             &PyInt_Type,
    /*tp_dict*/             0,
    /*tp_descr_get*/        0,
    /*tp_descr_set*/        0,
    /*tp_dictoffset*/       0,
    /*tp_init*/             0,
    /*tp_alloc*/            0,
    /*tp_new*/              PyInt_Type.tp_new,
    /*tp_free*/             0,
    /*tp_is_gc*/            0,
    /*tp_bases*/            0,
    /*tp_mro*/              0,
    /*tp_cache*/            0,
    /*tp_subclasses*/       0,
    /*tp_weaklist*/         0
};



void init_QStyleOptionTab(PyObject* module)
{
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTAB_IDX] = reinterpret_cast<PyTypeObject*>(&Sbk_QStyleOptionTab_Type);

    Shiboken::ObjectType::initPrivateData(&Sbk_QStyleOptionTab_Type);
    Sbk_QStyleOptionTab_Type.super.ht_type.tp_base = SbkPySide_QtGuiTypes[SBK_QSTYLEOPTION_IDX];
    Shiboken::ObjectType::setDestructorFunction(&Sbk_QStyleOptionTab_Type, &Shiboken::callCppDestructor<QStyleOptionTab >);
    Py_INCREF((PyObject*)&Sbk_QStyleOptionTab_Type); //Incref due the 'PyModule_AddObject' steals the reference.
    if (PyType_Ready((PyTypeObject*)&Sbk_QStyleOptionTab_Type) < 0)
        return;

    Shiboken::ObjectType::setOriginalName(&Sbk_QStyleOptionTab_Type, "QStyleOptionTab");
    PyModule_AddObject(module, "QStyleOptionTab",
        ((PyObject*)&Sbk_QStyleOptionTab_Type));

    // Initialize enums
    PyObject* enumItem;

    // init enum: StyleOptionVersion
    PyTypeObject* SbkPySide_QtGui_QStyleOptionTab_StyleOptionVersion = Shiboken::Enum::newType("PySide.QtGui.QStyleOptionTab.StyleOptionVersion");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTAB_STYLEOPTIONVERSION_IDX] = SbkPySide_QtGui_QStyleOptionTab_StyleOptionVersion;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionTab_StyleOptionVersion) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionTab_Type.super.ht_type.tp_dict,
            "StyleOptionVersion",((PyObject*)SbkPySide_QtGui_QStyleOptionTab_StyleOptionVersion));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionTab_StyleOptionVersion,(long) QStyleOptionTab::Version, "Version");
    PyDict_SetItemString(Sbk_QStyleOptionTab_Type.super.ht_type.tp_dict,"Version", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionTab_StyleOptionVersion->tp_dict,"Version", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionTab::StyleOptionVersion");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::StyleOptionVersion");
    // end of enum StyleOptionVersion

    // init enum: CornerWidget
    PyTypeObject* SbkPySide_QtGui_QStyleOptionTab_CornerWidget = Shiboken::Enum::newType("PySide.QtGui.QStyleOptionTab.CornerWidget");
    SbkPySide_QtGui_QStyleOptionTab_CornerWidget->tp_as_number = &SbkPySide_QtGui_QStyleOptionTab_CornerWidget_as_number;
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTAB_CORNERWIDGET_IDX] = SbkPySide_QtGui_QStyleOptionTab_CornerWidget;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionTab_CornerWidget) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionTab_Type.super.ht_type.tp_dict,
            "CornerWidget",((PyObject*)SbkPySide_QtGui_QStyleOptionTab_CornerWidget));

    // init flags class: QFlags<QStyleOptionTab::CornerWidget>
    SbkPySide_QtGuiTypes[SBK_QFLAGS_QSTYLEOPTIONTAB_CORNERWIDGET__IDX] = &SbkPySide_QtGui_QStyleOptionTab_CornerWidgets_Type;
    if (PyType_Ready((PyTypeObject*)&SbkPySide_QtGui_QStyleOptionTab_CornerWidgets_Type) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionTab_Type.super.ht_type.tp_dict,
            "CornerWidgets",((PyObject*)&SbkPySide_QtGui_QStyleOptionTab_CornerWidgets_Type));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionTab_CornerWidget,(long) QStyleOptionTab::NoCornerWidgets, "NoCornerWidgets");
    PyDict_SetItemString(Sbk_QStyleOptionTab_Type.super.ht_type.tp_dict,"NoCornerWidgets", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionTab_CornerWidget->tp_dict,"NoCornerWidgets", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionTab_CornerWidget,(long) QStyleOptionTab::LeftCornerWidget, "LeftCornerWidget");
    PyDict_SetItemString(Sbk_QStyleOptionTab_Type.super.ht_type.tp_dict,"LeftCornerWidget", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionTab_CornerWidget->tp_dict,"LeftCornerWidget", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionTab_CornerWidget,(long) QStyleOptionTab::RightCornerWidget, "RightCornerWidget");
    PyDict_SetItemString(Sbk_QStyleOptionTab_Type.super.ht_type.tp_dict,"RightCornerWidget", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionTab_CornerWidget->tp_dict,"RightCornerWidget", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionTab::CornerWidget");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::CornerWidget");
    // end of enum CornerWidget

    // init enum: TabPosition
    PyTypeObject* SbkPySide_QtGui_QStyleOptionTab_TabPosition = Shiboken::Enum::newType("PySide.QtGui.QStyleOptionTab.TabPosition");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTAB_TABPOSITION_IDX] = SbkPySide_QtGui_QStyleOptionTab_TabPosition;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionTab_TabPosition) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionTab_Type.super.ht_type.tp_dict,
            "TabPosition",((PyObject*)SbkPySide_QtGui_QStyleOptionTab_TabPosition));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionTab_TabPosition,(long) QStyleOptionTab::Beginning, "Beginning");
    PyDict_SetItemString(Sbk_QStyleOptionTab_Type.super.ht_type.tp_dict,"Beginning", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionTab_TabPosition->tp_dict,"Beginning", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionTab_TabPosition,(long) QStyleOptionTab::Middle, "Middle");
    PyDict_SetItemString(Sbk_QStyleOptionTab_Type.super.ht_type.tp_dict,"Middle", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionTab_TabPosition->tp_dict,"Middle", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionTab_TabPosition,(long) QStyleOptionTab::End, "End");
    PyDict_SetItemString(Sbk_QStyleOptionTab_Type.super.ht_type.tp_dict,"End", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionTab_TabPosition->tp_dict,"End", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionTab_TabPosition,(long) QStyleOptionTab::OnlyOneTab, "OnlyOneTab");
    PyDict_SetItemString(Sbk_QStyleOptionTab_Type.super.ht_type.tp_dict,"OnlyOneTab", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionTab_TabPosition->tp_dict,"OnlyOneTab", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionTab::TabPosition");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::TabPosition");
    // end of enum TabPosition

    // init enum: SelectedPosition
    PyTypeObject* SbkPySide_QtGui_QStyleOptionTab_SelectedPosition = Shiboken::Enum::newType("PySide.QtGui.QStyleOptionTab.SelectedPosition");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTAB_SELECTEDPOSITION_IDX] = SbkPySide_QtGui_QStyleOptionTab_SelectedPosition;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionTab_SelectedPosition) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionTab_Type.super.ht_type.tp_dict,
            "SelectedPosition",((PyObject*)SbkPySide_QtGui_QStyleOptionTab_SelectedPosition));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionTab_SelectedPosition,(long) QStyleOptionTab::NotAdjacent, "NotAdjacent");
    PyDict_SetItemString(Sbk_QStyleOptionTab_Type.super.ht_type.tp_dict,"NotAdjacent", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionTab_SelectedPosition->tp_dict,"NotAdjacent", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionTab_SelectedPosition,(long) QStyleOptionTab::NextIsSelected, "NextIsSelected");
    PyDict_SetItemString(Sbk_QStyleOptionTab_Type.super.ht_type.tp_dict,"NextIsSelected", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionTab_SelectedPosition->tp_dict,"NextIsSelected", enumItem);
    Py_DECREF(enumItem);
    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionTab_SelectedPosition,(long) QStyleOptionTab::PreviousIsSelected, "PreviousIsSelected");
    PyDict_SetItemString(Sbk_QStyleOptionTab_Type.super.ht_type.tp_dict,"PreviousIsSelected", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionTab_SelectedPosition->tp_dict,"PreviousIsSelected", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionTab::SelectedPosition");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::SelectedPosition");
    // end of enum SelectedPosition

    // init enum: StyleOptionType
    PyTypeObject* SbkPySide_QtGui_QStyleOptionTab_StyleOptionType = Shiboken::Enum::newType("PySide.QtGui.QStyleOptionTab.StyleOptionType");
    SbkPySide_QtGuiTypes[SBK_QSTYLEOPTIONTAB_STYLEOPTIONTYPE_IDX] = SbkPySide_QtGui_QStyleOptionTab_StyleOptionType;
    if (PyType_Ready(SbkPySide_QtGui_QStyleOptionTab_StyleOptionType) < 0)
        return;
    PyDict_SetItemString(Sbk_QStyleOptionTab_Type.super.ht_type.tp_dict,
            "StyleOptionType",((PyObject*)SbkPySide_QtGui_QStyleOptionTab_StyleOptionType));

    enumItem = Shiboken::Enum::newItem(SbkPySide_QtGui_QStyleOptionTab_StyleOptionType,(long) QStyleOptionTab::Type, "Type");
    PyDict_SetItemString(Sbk_QStyleOptionTab_Type.super.ht_type.tp_dict,"Type", enumItem);
    Py_DECREF(enumItem);
    PyDict_SetItemString(SbkPySide_QtGui_QStyleOptionTab_StyleOptionType->tp_dict,"Type", enumItem);
    Py_DECREF(enumItem);
    Shiboken::TypeResolver::createValueTypeResolver<int>("QStyleOptionTab::StyleOptionType");
    Shiboken::TypeResolver::createValueTypeResolver<int>("::StyleOptionType");
    // end of enum StyleOptionType


    Shiboken::TypeResolver::createValueTypeResolver<QStyleOptionTab >("QStyleOptionTab");
    Shiboken::TypeResolver::createObjectTypeResolver<QStyleOptionTab >("QStyleOptionTab*");
    Shiboken::TypeResolver::createValueTypeResolver<QStyleOptionTab >(typeid(QStyleOptionTab).name());
    qRegisterMetaType< ::QStyleOptionTab >("QStyleOptionTab");
    qRegisterMetaType< ::QStyleOptionTab::StyleOptionVersion >("QStyleOptionTab::StyleOptionVersion");
    qRegisterMetaType< ::QStyleOptionTab::CornerWidget >("QStyleOptionTab::CornerWidget");
    qRegisterMetaType< ::QStyleOptionTab::CornerWidgets >("QStyleOptionTab::CornerWidgets");
    qRegisterMetaType< ::QStyleOptionTab::TabPosition >("QStyleOptionTab::TabPosition");
    qRegisterMetaType< ::QStyleOptionTab::SelectedPosition >("QStyleOptionTab::SelectedPosition");
    qRegisterMetaType< ::QStyleOptionTab::StyleOptionType >("QStyleOptionTab::StyleOptionType");
}

